<%@ page contentType="text/html; charset=utf-8"%>
<%@ page language="java" %>
<%@ page import="com.ibm.hats.common.connmgr.*,com.ibm.hats.common.*, com.ibm.hats.hatsle.*,com.ibm.hats.runtime.*, java.util.*, com.ibm.hats.util.*, com.ibm.hats.transform.*, com.ibm.hats.transform.components.*, com.ibm.hats.transform.widgets.*" %>
<%@ taglib uri="hats.tld" prefix="HATS" %>

<%
	Properties applicationSettings = ConfigServlet.getApplicationSettingsFromSession(session);
	//Hashtable hostSessions = (Hashtable)applicationSettings.get(Application.SESSIONS_TAG);
	//Properties hostSessionSettings = (Properties)hostSessions.get(applicationSettings.getProperty(Application.DEFAULT_ATTR));
	Hashtable classSettings = (Hashtable)applicationSettings.get(Application.CLASS_SETTINGS_TAG);


    Properties connectionProperties= (Properties) classSettings.get(HATSConnectionsTag.CLASS_NAME);
    if(connectionProperties !=null){
        connectionProperties = (Properties) connectionProperties.clone();
    }
    
    Properties overrideProperties= (Properties) classSettings.get(ConnectionsListOverrides.CLASS_NAME);
    if(overrideProperties !=null){
        overrideProperties = (Properties) overrideProperties.clone();
    }
        String ordering = connectionProperties.containsKey("ordering")?connectionProperties.getProperty("ordering"):"";

        ArrayList order=HATSConnectionsTag.createOrderedList(ordering);
        if(order==null){
        	order = new ArrayList();
        }
    Properties standardConn = null;
    Hashtable connInfo= ((Hashtable)(applicationSettings.get(Application.CONNECTIONS_TAG)));
    if ( connInfo!=null )
    {
        String defaultConnName = (String) applicationSettings.get(Application.DEFAULT_ATTR);
        standardConn = connInfo.containsKey(defaultConnName) ? 
                       (Properties) connInfo.get(defaultConnName) : new Properties();
    } else
    {
        standardConn = new Properties();
    }

	Locale userLocale = RuntimeFunctions.getUserLocaleFromSession(session, request.getLocale());	

	// Locale-specific strings
    HatsMsgs msgs = ConfigServlet.getMessages(request);
	String enabledString = msgs.get("YES");
	String disabledString = msgs.get("NO");
	
	String enabledImageTag = "<img src=\"" + request.getContextPath() + "/config/images/checked.gif\" alt=\"" + enabledString + "\">";
	String disabledImageTag = "<img src=\"" + request.getContextPath() + "/config/images/unchecked.gif\" alt=\"" + disabledString + "\">";
    
	Properties appKeypadSettings = (Properties)classSettings.get(ApplicationKeypadTag.CLASS_NAME);    
    boolean appKeypadEnabled = new Boolean(appKeypadSettings.getProperty(ApplicationKeypadTag.PROPERTY_SHOW)).booleanValue();
    
    Properties hostKeypadSettings = (Properties)classSettings.get(HostKeypadTag.CLASS_NAME);    
    boolean hostKeypadEnabled = new Boolean(hostKeypadSettings.getProperty(HostKeypadTag.PROPERTY_SHOW)).booleanValue();

	Properties keyboardSupportSettings = (Properties)classSettings.get(KeyboardSupport.CLASS_NAME);	
    boolean keyboardSupportEnabled = new Boolean(keyboardSupportSettings.getProperty(KeyboardSupport.PROPERTY_ENABLE)).booleanValue();    

	// Template configuration
	String templateName = applicationSettings.getProperty(Application.TEMPLATE_ATTR);
	Vector v = ConfigServlet.getCustomizableTemplateSettings(application, templateName, msgs);
	Properties templateSettings = (Properties)classSettings.get(TemplateSettings.CLASS_NAME);
	String templateConfigString = "";
	for (int i = 0; i < v.size(); i++) {
		TemplateSettingInfo tsi = (TemplateSettingInfo)v.get(i);
		if (tsi.isConfigurable()) {
			String caption = tsi.getCaption();
			String value = templateSettings.getProperty(tsi.getName());
			if (value == null) {
				value = tsi.getDefaultValue();
			}
			
			templateConfigString = templateConfigString + "<b>" + caption + "</b> " + DynamicWebPropertiesFactory.getTranslatedTemplateString(value,msgs.getBundle());
			if (i < v.size() - 1) {
				templateConfigString = templateConfigString + "; ";
			}	
		}	
	}
	
	// Transformation settings
	//Properties defaultWidgetSettings = (Properties)classSettings.get(DefaultWidget.CLASSNAME);

	boolean detectFunctionKeys = true;//new Boolean(defaultWidgetSettings.getProperty(DefaultWidget.PROPERTY_SUBSTITUTE_PK_KEYS_1)).booleanValue();
	boolean detectSelectionLists = true;//new Boolean(defaultWidgetSettings.getProperty(DefaultWidget.PROPERTY_SELECTION_LISTS)).booleanValue();
	boolean detectTables = false;//new Boolean(defaultWidgetSettings.getProperty(DefaultWidget.PROPERTY_LOOK_FOR_TABLES)).booleanValue();
    boolean detectSubfiles = true;//new Boolean(defaultWidgetSettings.getProperty(DefaultWidget.PROPERTY_SUBFILES)).booleanValue();
	boolean detectFields = true;

    Hashtable dre=(Hashtable)applicationSettings.get(DefaultRenderingEngine.TAG_DEFAULT_RENDERING);
    RenderingSet rs =  (RenderingSet) dre.get(RenderingSet.DEFAULT_RENDERING_SET_NAME);
    //find the renderingItem                             
    RenderingItem ri =null;
    for(int i=0;i<rs.size();i++){
        ri=(RenderingItem) rs.get(i);               
        String component=ri.getComponentClassName();
        String widget = ri.getWidgetClassName();
        //change settings if appropriate
        if(component.equalsIgnoreCase("com.ibm.hats.transform.components.SelectionListComponent")){
            detectSelectionLists = ri.isEnabled();
        }else if(component.equalsIgnoreCase("com.ibm.hats.transform.components.FunctionKeyComponent")){
            detectFunctionKeys = ri.isEnabled();
        }else if(component.equalsIgnoreCase("com.ibm.hats.transform.components.SubfileComponent")){
            detectSubfiles = ri.isEnabled();
        }else if(component.equalsIgnoreCase("com.ibm.hats.transform.components.FieldTableComponent")){
            detectTables= ri.isEnabled();
        }else if(component.equalsIgnoreCase("com.ibm.hats.transform.components.FieldComponent")){
            detectFields= ri.isEnabled();
        }
    }

	StringBuffer b = new StringBuffer(256);
	b.append((detectFunctionKeys ? msgs.get("FUNCTION_KEYS") + ", " : ""));
	b.append((detectSelectionLists ? msgs.get("SELECTION_LISTS") + ", " : ""));
	b.append((detectTables ? msgs.get("TABLES") + ", " : ""));
	b.append((detectSubfiles ? msgs.get("SUBFILES") + ", " : ""));
    b.append((detectFields ? msgs.get("FIELDS") + ", " : ""));
	
	String transformationSettingsString = b.toString();
	if (transformationSettingsString.endsWith(", ")) {
		transformationSettingsString = transformationSettingsString.substring(0, transformationSettingsString.length() - 2);
	}
	
	if (transformationSettingsString.length() > 0) {
		transformationSettingsString = "<b>" + msgs.get("AUTOMATICALLY_DETECT") + "</b> " + transformationSettingsString + ".";
	}
	
	//boolean useMonospacedFont = new Boolean(defaultWidgetSettings.getProperty(DefaultWidget.PROPERTY_TELETYPE)).booleanValue();
	//transformationSettingsString += " <b>" + msgs.get("USE_MONOSPACE_FONT") + "</b> " + (useMonospacedFont ? enabledString : disabledString) + ".";
	
	//boolean preserveFieldColors = new Boolean(defaultWidgetSettings.getProperty(DefaultWidget.PROPERTY_PRESERVE_COLORS)).booleanValue();	
	//transformationSettingsString += " <b>" + msgs.get("PRESERVE_FIELD_COLORS_FIELD") + "</b> " + (preserveFieldColors ? enabledString : disabledString) + ".";
	
	//String charRendering = null;
	//String selection = defaultWidgetSettings.getProperty(DefaultWidget.PROPERTY_CHARACTER_RENDERING);
	//if (selection.equals(DefaultWidget.CHAR_RENDERING_NEVER)) {
	//	charRendering = msgs.get("CHAR_RENDERING_NEVER");
	//} else if (selection.equals(DefaultWidget.CHAR_RENDERING_WITH_POPUPS)) {
	//	charRendering = msgs.get("CHAR_RENDERING_WITH_POPUPS");
	//} else {
	//	charRendering = msgs.get("CHAR_RENDERING_ALWAYS");
	//}
	//transformationSettingsString += " <b>" + msgs.get("CHAR_RENDERING") + "</b> " + charRendering + ".";
%>

<html>
<HEAD>
<title><%= msgs.get("WIZARD_TITLE") + " : " + msgs.get("SUMMARY_TITLE") %></title>
<META name="GENERATOR" content="IBM WebSphere Studio">
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<link rel="stylesheet" href="<%= request.getContextPath() %>/main.css" type="text/css" />
<style>
	a.subHeaderLink:link, a.subHeaderLink:visited {
		color: white;
	}	
	
	td.fieldHeader {
		background-color: white;
		font-weight: bold;
	}
</style>
</HEAD>



<body>  

<script language="javascript1.2">
  function navigateToStep(step) {
     document.forms[0].<%= ConfigServlet.PARAM_NEXT_STEP %>.value = step;
     document.forms[0].<%= ConfigServlet.PARAM_UPDATE %>.value = "true";
     document.forms[0].<%= ConfigServlet.PARAM_CANCEL %>.value = "false";
     document.forms[0].submit();
  }  

  function cancelWizard() {
	 if (confirm("<%= msgs.get("CANCEL_MESSAGE") %>")) {
		 	if (top.location != document.location) {
			 	document.forms[0].<%= ConfigServlet.PARAM_FUNCTION %>.value = "<%= ConfigServlet.FUNCTION_ADMIN %>";
			} else {
			 document.forms[0].<%= ConfigServlet.PARAM_FUNCTION %>.value = ""; 
		    }
		 document.forms[0].<%= ConfigServlet.PARAM_CANCEL %>.value = "true";
	     document.forms[0].<%= ConfigServlet.PARAM_UPDATE %>.value = "false";
	     document.forms[0].submit();   
	 }  
  }

<HATS:JavaScript type="help" />
</script>

<form method="post" action="<%= response.encodeURL(request.getContextPath() + "/config") %>">
<input type="hidden" name="<%= ConfigServlet.PARAM_CURRENT_STEP %>" value="<%= ConfigServlet.STEP_SUMMARY %>">
<input type="hidden" name="<%= ConfigServlet.PARAM_FUNCTION %>" value="">
<input type="hidden" name="<%= ConfigServlet.PARAM_NEXT_STEP %>" value="<%= ConfigServlet.STEP_COMPLETE %>">
<input type="hidden" name="<%= ConfigServlet.PARAM_CANCEL %>" value="false">
<input type="hidden" name="<%= ConfigServlet.PARAM_UPDATE %>" value="true">

<table width=500 border=0 cellspacing=1 cellpadding=4 bgcolor="#888888">
   <tr>
    <td class="header">
    <table border=0 cellpadding=0 cellspacing=0 width=100%>
      <tr>
        <td class="header"><%= msgs.get("SUMMARY_TITLE") %></td>
        <td align="right" class="header"><HATS:HelpLink topicID="cfgsumry" />
      </tr>
    </table>
    </td>
  </tr>
  <tr class="instructions">
   <td colspan=2>
   <%= msgs.get("SUMMARY_INSTRUCTIONS") %>
    </td>
  </tr>
</table>
<%
	if (ConfigServlet.doValidationErrorsExist(request)) {
		out.println("<p>");
		out.println(ConfigServlet.generateValidationErrorsTable(request, "validationErrors", "validationError"));
	}
%>
<p>
<table border=0 cellspacing=1 cellpadding=4 bgcolor="#888888">
  <!-- connection settings -->
  <tr class="subHeader">
	<%
		String actionString = "navigateToStep('" + ConfigServlet.STEP_MULTIPLE_CONNECTIONS + "')";
	%>	
    <td><a class="subHeaderLink" href="javascript:<%= actionString %>" onClick="<%= actionString %>" onKeyPress="<%= actionString %>"><%= msgs.get("CONNECTION_SETTINGS_SUMMARY_TITLE") %></a></td>
  </tr>
  <tr>
    <td class="field" width=100%>
            <TABLE width=100% cellpadding=4 cellspacing=0 border=0>
            	<TBODY>
            		<TR>
            			<TD style="background-color:white; font-weight:bold;" ><%= msgs.get("CONNECTION_NAME_FIELD") %></TD>
            			<TD style="background-color:white; font-weight:bold;" ><%= msgs.get("HOST_NAME_FIELD") %></TD>
                   		<TD style="background-color:white; font-weight:bold;" ><%= msgs.get("PORT_FIELD") %></TD>
            			<TD style="background-color:white; font-weight:bold;" ><%= msgs.get("CODE_PAGE_FIELD") %></TD>
                        <TD style="background-color:white; font-weight:bold;" ><%= msgs.get("WORKSTATION_ID_FIELD") %></TD>
                        <TD style="background-color:white; font-weight:bold;" ><%= msgs.get("SSL_ENABLED_FIELD") %></TD>
            		</TR>
            		<TR>
            		</TR>
            <%
            try{ 
                for(int i=0;i<order.size();i++){
                    String connectionName=(String) order.get(i);
                    if(connectionName==null){
                    	connectionName="";
                    }

                    String def = connectionProperties.containsKey("default")?connectionProperties.getProperty("default"):"";
                    boolean isdef=connectionName.equalsIgnoreCase(def);
                    String defind = isdef?"&nbsp;"+msgs.get("DEFAULT_INDICATOR"):"";


                    String overrides = overrideProperties.getProperty(connectionName);
                    if(overrides==null){overrides="";}
                    
                    Properties storage = new Properties();
                    ConnectionsListOverrides.readPropertiesFromString(overrides, storage);
                    String description = storage.containsKey(HodPoolSpec.DESCRIPTION_ATTR)?storage.getProperty(HodPoolSpec.DESCRIPTION_ATTR):"";
                    String hostName = storage.containsKey(HodPoolSpec.HOST_NAME_ATTR)?storage.getProperty(HodPoolSpec.HOST_NAME_ATTR):standardConn.getProperty(HodPoolSpec.HOST_NAME_ATTR);
                    String port = storage.containsKey(HodPoolSpec.PORT_ATTR)?storage.getProperty(HodPoolSpec.PORT_ATTR):standardConn.getProperty(HodPoolSpec.PORT_ATTR);
                    String codepage = storage.containsKey(HodPoolSpec.CODE_PAGE_ATTR)?storage.getProperty(HodPoolSpec.CODE_PAGE_ATTR):standardConn.getProperty(HodPoolSpec.CODE_PAGE_ATTR);
                    String codepagekey = storage.containsKey(HodPoolSpec.CODE_PAGE_KEY_ATTR)?storage.getProperty(HodPoolSpec.CODE_PAGE_KEY_ATTR):standardConn.getProperty(HodPoolSpec.CODE_PAGE_KEY_ATTR);
                    String wsIDSource = storage.containsKey(HodPoolSpec.WORKSTATION_ID_SOURCE_ATTR)?storage.getProperty(HodPoolSpec.WORKSTATION_ID_SOURCE_ATTR):standardConn.getProperty(HodPoolSpec.WORKSTATION_ID_SOURCE_ATTR);
                    if(wsIDSource == null){
                    	wsIDSource = HodConnSpec.WORKSTATION_ID_AUTOMATIC;
                    }
                    String wsID = storage.containsKey(HodPoolSpec.WORKSTATION_ID_ATTR)?storage.getProperty(HodPoolSpec.WORKSTATION_ID_ATTR):standardConn.getProperty(HodPoolSpec.WORKSTATION_ID_ATTR);
                    if(wsID ==null){
                        wsID="";
                    }
                    String workstationIDSource = null;
                    if (wsIDSource.equals(HodConnSpec.WORKSTATION_ID_PROMPT)) {
                	    workstationIDSource = msgs.get("WS_ID_PROMPT_USER");
                	} else if (wsIDSource.equals(HodConnSpec.WORKSTATION_ID_VALUE)) {
                	    workstationIDSource = msgs.get("WS_ID_FROM_VALUE", wsID);
                    } else if (wsIDSource.equals(HodConnSpec.WORKSTATION_ID_SESSION_VARIABLE)) {
                	    workstationIDSource = msgs.get("WS_ID_FROM_SESSION_VAR", wsID);
                    } else if (wsIDSource.equals(HodConnSpec.WORKSTATION_ID_AUTOMATIC)) {
                	    workstationIDSource = msgs.get("WS_ID_SERVER_ASSIGNED");
                	} else{
                        workstationIDSource = msgs.get("WS_ID_SERVER_ASSIGNED");
                    }
                    String codepagestring = CommonFunctions.getCodePageDescriptionFromCodeAndKey(codepage, codepagekey, userLocale) ;
                
                    String sslstring = storage.containsKey("SSL")?storage.getProperty("SSL"):standardConn.getProperty("SSL");
                
                    boolean sslEnabled = new Boolean(sslstring).booleanValue();
                
                    String ssl = (sslEnabled ? enabledString : disabledString);
            %>	
            		<TR >
            			<TD class="field">&nbsp;<%=connectionName+defind%></TD>
            			<TD class="field">&nbsp;<%=hostName%></TD>
                        <TD class="field">&nbsp;<%=port%></TD>
                        <TD class="field">&nbsp;<%=codepagestring%></TD>
                        <TD class="field">&nbsp;<%=workstationIDSource%></TD>
                        <TD class="field">&nbsp;<%=ssl%></TD>
            		</TR>
           <%
                }
            }catch(Throwable t){
            	t.printStackTrace();
            }
            %>         
                       	
            	</TBODY>
            </TABLE>
    </td>
  </tr>
  <tr class="subHeader">
	<%
		actionString = "navigateToStep('" + ConfigServlet.STEP_TEMPLATE + "')";
	%>
    <td><a class="subHeaderLink" href="javascript:<%= actionString %>" onClick="<%= actionString %>" onKeyPress="<%= actionString %>"><%= msgs.get("TEMPLATE_SUMMARY_TITLE") %></a></td>
  </tr>
  <tr>
    <td class="field" width=100%>
    <table width=100% cellpadding=4 cellspacing=0 border=0>
      <tr>
        <td class="fieldHeader" width="35%"><%= msgs.get("TEMPLATE_FIELD") %></td>
        <td class="field" width="65%"><%= applicationSettings.getProperty(Application.TEMPLATE_ATTR) %>
      </tr>      <tr>
        <td class="fieldHeader"><%= msgs.get("SHOW_APP_KEYPAD_FIELD") %></td>
        <td class="field"><%= (appKeypadEnabled ? enabledString : disabledString) %></td>
      </tr>
      <tr>
        <td class="fieldHeader"><%= msgs.get("SHOW_HOST_KEYPAD_FIELD") %></td>
        <td class="field"><%= (hostKeypadEnabled ? enabledString : disabledString) %></td>
      </tr>
      <tr>
        <td class="fieldHeader"><%= msgs.get("KEYBOARD_SUPPORT_FIELD") %></td>
        <td class="field"><%= (keyboardSupportEnabled ? enabledString : disabledString) %></td>
      </tr>      
    </table>
    </td>
  </tr>
  <tr class="subHeader">
	<%
		actionString = "navigateToStep('" + ConfigServlet.STEP_CONFIGURE_TEMPLATE + "')";
	%>
    <td><a class="subHeaderLink" href="javascript:<%= actionString %>" onClick="<%= actionString %>" onKeyPress="<%= actionString %>"><%= msgs.get("TEMPLATE_CONFIGURATION_SUMMARY_TITLE") %></a></td>
  </tr>
  <tr>
    <td class="field" width=100%>
    <table width=100% cellpadding=4 cellspacing=0 border=0>
      <tr>
        <td class="field">
        <%= templateConfigString %>
        </td>
      </tr>
    </table>
    </td>
  </tr>  
  <tr class="subHeader">
	<%
		actionString = "navigateToStep('" + ConfigServlet.STEP_TRANSFORMATION_SETTINGS + "')";
	%>
    <td><a class="subHeaderLink" href="javascript:<%= actionString %>" onClick="<%= actionString %>" onKeyPress="<%= actionString %>"><%= msgs.get("TRANSFORMATION_SETTINGS_SUMMARY_TITLE") %></a></td>
  </tr>
  <tr>
    <td class="field" width=100%>
    <table width=100% cellpadding=4 cellspacing=0 border=0>
      <tr>
        <td class="field">
        <%= transformationSettingsString %>
        </td>
      </tr>
    </table>
    </td>
  </tr>  
  <tr>
    <td class="field"><p>
      <input type="checkbox" name="<%= Application.ACTIVE_ATTR %>" ID=A <%= (new Boolean(applicationSettings.getProperty(Application.ACTIVE_ATTR)).booleanValue() ? " checked" : "")%>><label for=A accesskey=A><%= msgs.get("ACTIVATE_APPLICATION_OPTION") %></label><br>
    </p></td>
  </tr>
</table>
<p>
<table border=0 cellspacing=1 cellpadding=4 width=500 bgcolor="BLACK">
  <tr class="footer">
    <td colspan=2>
      <input class="footerButton" type="button" value="<%= msgs.get("BACK_BUTTON") %>" onClick="navigateToStep('<%= ConfigServlet.STEP_TRANSFORMATION_SETTINGS %>')">
      <input class="footerButton" type="button" value="<%= msgs.get("FINISH_BUTTON") %>"  onClick="navigateToStep('<%= ConfigServlet.STEP_COMPLETE %>')">
      <input class="footerButton" type="button" value="<%= msgs.get("CANCEL_BUTTON") %>" onClick="cancelWizard()">
    </td>
  </tr>
</table>
</form> 

</body>
</html>




